
if exist('REVS','var') && REVS.verbose  disp(['Loading ' mfilename]); end

controls = class_REVS_EVM_control();

controls.CTP_torque = class_REVS_dynamic_lookup;
controls.CTP_torque.axis_1.signal = 'vehicle.veh_spd_mps';
controls.CTP_torque.axis_1.breakpoints = [0 .05 0.2 0.6 1.9 7 12 20];
controls.CTP_torque.table = [0 40 40 23 0 0 0 0]; % changed from the original [0 40 40 23 0 -10 -15 -20] on 04072022

controls.regen_speed_derate = class_REVS_dynamic_lookup;
controls.regen_speed_derate.axis_1.signal = 'vehicle.veh_spd_mps';
controls.regen_speed_derate.axis_1.breakpoints = [0 2.15 6.18 10];
controls.regen_speed_derate.table = [0 0 1 1];

controls.regen_SoC_derate = class_REVS_dynamic_lookup;
controls.regen_SoC_derate.axis_1.signal = 'powertrain.electric.primary_batt.batt_SoC_norm';
controls.regen_SoC_derate.axis_1.breakpoints = [0.97 1.00];
controls.regen_SoC_derate.table = [1.00 0.00];

controls.trq_limit_filter.numerator = [1];
controls.trq_limit_filter.denominator = [0.1 1];

controls.eng_load_norm = 0;
controls.drive_motor_enable = true;  
controls.boost_dcdc_tgt_V = 0;

controls.regen_torque_constraint = class_REVS_dynamic_lookup;
controls.regen_torque_constraint.axis_1.signal = 'vehicle.veh_spd_mps';
controls.regen_torque_constraint.axis_1.breakpoints = [0 2.15 6.18 10];
controls.regen_torque_constraint.table = -[0 0 133.955 133.955]; % from swri test data of 2018 model 3 mr
