function package = REVS_config_transmission()
%REVS_CONFIG_AMBIENT REVS configuration keys for ambient conditions


package = class_REVS_sim_config_options();

package.keys = [ ...
    class_REVS_sim_config_key('transmission',                   'tag',  'TRANS',    'eval',   false); 
    
    class_REVS_sim_config_key('transmission_vintage',           'tag',  'TRX_VTG');

    class_REVS_sim_config_key('TC_K_factor',                    'tag',  'TCK');   
    class_REVS_sim_config_key('TC_stall_rpm',                   'tag',  'TCSTALL');

    class_REVS_sim_config_key('TC_torque_ratio',                'tag',  'TCTR');
    
%     class_REVS_sim_config_key('TC_torque_ratio_auto',           'tag',    'TCTR_AUTO','default', 0);
    class_REVS_sim_config_key('TC_lockup_efficiency_pct',       'tag',  'TCLUEFF_PCT');
    
    class_REVS_sim_config_key('transmission_autoscale',         'tag',  'NTRT',   'default', 0);

];

        
package.case_preprocess_scripts = [ ...
    class_REVS_sim_config_script('REVS_config_transmission_load', 1)
    class_REVS_sim_config_script('REVS_config_transmission_modify', 5)
    ];
