classdef class_REVS_EVM_control < class_REVS_control
    %class_REVS_P2_control
    %   For mild hybrid P2 controls
    
    properties
        CTP_torque                  class_REVS_dynamic_lookup
        regen_speed_derate          class_REVS_dynamic_lookup
        regen_SoC_derate            class_REVS_dynamic_lookup
        trq_limit_filter
        eng_load_norm
        drive_motor_enable
        boost_dcdc_tgt_V
        
        regen_torque_constraint     class_REVS_dynamic_lookup
    end
    
    methods
    end
    
    %% code block below contains earlier commented code
%     properties
%         %        hybrid_max_torque_speeds_radps
%         %        hybrid_max_torque_curve_Nm
%                         
%         
%         max_battery_power_W
%         regenerative_braking_enable
%         
%         stop_delay_secs
%         start_stop_enable
%         start_stop_off_delay_secs
%         cold_start_enable
%         start_stop_warmup_condition
%         hot_soak_start_enable
%         hot_soak_warmup_start_condition
%         
%         pedal_map_type = enum_engine_pedal_map_type.lookup_table;
%         pedal_map_engine_torque_Nm;
%         
%         charge_sustain_soc_band
%         
%         drive_motor_torque_limit_soc_norm
%         drive_motor_torque_limit_norm
%         
%         drive_regen_torque_limit_soc_norm
%         drive_regen_torque_limit_norm
%         
%         drive_regen_speed_limit_mps
%         drive_regen_speed_limit_norm
%         
%        engine_cruise_activate_mps
%        
%        min_bsfc_speed_radps
%        min_bsfc_torque_Nm
%        min_bsfc_power_W
%        
%        
%        emachine_saturation_speed_mps
%        emachine_saturation_torque_Nm
%        
%        battery_target_soc_norm
%        battery_hyst_soc_norm
%        battery_loadlevel_soc_norm
%        
%        CS_recharge_power_soc_norm
%        CS_recharge_power_W
%        
%        LL_enable_power_threshold_kW
%        LL_enable_speed_threshold_mph
%        
%        drive_motor_assist_soc_derate_soc_norm
%        drive_motor_assist_soc_derate_norm
%        
%        max_EV_speed_mph
%        
%        engine_min_on_time_secs
%        engine_off_delay_secs
%        engine_start_min_mps = 5.2;
%        
%        engine_strategy
%        
%        max_wheel_torque_Nm
%        max_wheel_power_W
%        max_wheel_torque_vspeed_mps
%        max_wheel_torque_table
%        
%        launch_clutch_control    class_REVS_launch_clutch_control
%        
%        disconnect_clutch        class_REVS_clutch_control % disconnect clutch control
%        
%        battery_charge_request_W class_REVS_dynamic_lookup;
%        engine_start_power_kW    class_REVS_dynamic_lookup;
%         engine_stop_power_kW    class_REVS_dynamic_lookup
%     end
%     
%     properties ( Hidden)        
%         engine_max_torque_Nm;
%         engine_min_torque_Nm;
%         engine_torque_range_speed_radps;
%         engine_idle_speed_radps;
%     end
%     
%     methods %New methods added
%         
%         function obj = class_REVS_PS_control(varargin)
%             
%             % obj = obj@class_REVS_control(varargin{:});
%             
%             obj.stop_delay_secs         = 0.1;
%             obj.start_stop_enable       = true;
%             obj.start_stop_warmup_condition = '(@cycle_pos_secs >= 100)';
%             
%             obj.hybrid_system_enable        = true;
%             obj.regenerative_braking_enable = true;
%             
%             obj.pedal_map_engine_torque_Nm = class_REVS_dynamic_lookup();
%             
%             if nargin > 0
%                 [max_trq_spd_radps, max_trq_Nm] = engine.get_max_torque_curve();
%                 [min_trq_spd_radps, min_trq_Nm] = engine.get_min_torque_curve();
% 
%                 obj.engine_torque_range_speed_radps = unique( [max_trq_spd_radps(:);min_trq_spd_radps(:)])';
%                 
%                 obj.engine_max_torque_Nm = interp1(max_trq_spd_radps, max_trq_Nm, obj.engine_torque_range_speed_radps, 'linear','extrap');
%                 obj.engine_min_torque_Nm = interp1(min_trq_spd_radps, min_trq_Nm, obj.engine_torque_range_speed_radps, 'linear','extrap');
%                 
%                 obj.engine_max_torque_Nm = max(obj.engine_max_torque_Nm, obj.engine_min_torque_Nm);
%                                 
%                 obj.engine_idle_speed_radps = engine.nominal_idle_speed_radps;
%             end
%             
%         end
%         
%         function obj = update_powertrain_info(obj, engine, transmission, electric, vehicle)
%                 [max_trq_spd_radps, max_trq_Nm] = engine.get_max_torque_curve();
%                 [min_trq_spd_radps, min_trq_Nm] = engine.get_min_torque_curve();
% 
%                 obj.engine_torque_range_speed_radps = unique( [max_trq_spd_radps(:);min_trq_spd_radps(:)])';
%                 
%                 obj.engine_max_torque_Nm = interp1(max_trq_spd_radps, max_trq_Nm, obj.engine_torque_range_speed_radps, 'linear','extrap');
%                 obj.engine_min_torque_Nm = interp1(min_trq_spd_radps, min_trq_Nm, obj.engine_torque_range_speed_radps, 'linear','extrap');
%                 
%                 obj.engine_max_torque_Nm = max(obj.engine_max_torque_Nm, obj.engine_min_torque_Nm);
%                                 
%                 obj.engine_idle_speed_radps = engine.nominal_idle_speed_radps;
%       
%                 min_bsfc_curves = engine.min_bsfc_curves();
%                 obj.min_bsfc_speed_radps = min_bsfc_curves.speed_radps;
%                 obj.min_bsfc_torque_Nm = min_bsfc_curves.torque_Nm;
%                 obj.min_bsfc_power_W = min_bsfc_curves.power_W;
%                 
%                 
%                 % Based on Battery Pack / SOC
%                 cs_soc_band_init = [0.117 0.14];
%                 battery_cap_init = 8.8; %kWh
%                 usable_cap_init = battery_cap_init*diff(cs_soc_band_init); %Check 0.8
%                 
%                 battery_cap = (mean([electric.propulsion_battery.min_voltage_V, electric.propulsion_battery.max_voltage_V])*electric.propulsion_battery.capacity_nominal_Ah/1000);
%                 diff_cs_soc_band = usable_cap_init/battery_cap;
%                 
%                 
%                 obj.charge_sustain_soc_band = cs_soc_band_init;
%                 obj.charge_sustain_soc_band(1) = max(0.1,electric.propulsion_battery.initial_soc_norm);
%                 obj.charge_sustain_soc_band(2) = min(0.95,electric.propulsion_battery.initial_soc_norm + diff_cs_soc_band);
%                 
%                 
%                 soc_cs_low = min(obj.charge_sustain_soc_band );
%                 soc_cs_high = max(obj.charge_sustain_soc_band);
%                 soc_cs_range = soc_cs_high - soc_cs_low;
% 
%                 obj.battery_charge_request_W.axis_1.breakpoints = [0    soc_cs_low (soc_cs_range*0.44 + soc_cs_low) (soc_cs_range*0.57 + soc_cs_low)...
%                     soc_cs_high (soc_cs_high+soc_cs_range/2.1) (soc_cs_high+soc_cs_range/2) 1.0];
%                 
%                 obj.engine_start_power_kW.axis_1.breakpoints = [0 soc_cs_low (soc_cs_range*0.35 + soc_cs_low) (soc_cs_range*0.57 + soc_cs_low)...
%                     (soc_cs_high-soc_cs_range/4) soc_cs_high (soc_cs_high+soc_cs_range/4) 1];
% 
%                 obj.engine_stop_power_kW.axis_1.breakpoints =[ 0 soc_cs_low (soc_cs_range*0.35 + soc_cs_low) (soc_cs_range*0.45 + soc_cs_low) (soc_cs_range*0.57 + soc_cs_low) soc_cs_high (soc_cs_high+soc_cs_range/4) (soc_cs_high+soc_cs_range/3) 1];
% 
%                 
%                 
%                 % Wheels
%                 obj.max_wheel_torque_Nm = (electric.MG2.max_torque_Nm * electric.MG2.gear.ratio + electric.MG1.max_torque_Nm * (1 + transmission.planetary.R/transmission.planetary.S)) * vehicle.drive_axle1.final_drive.gear_ratio;
%                 obj.max_wheel_power_W   = engine.max_power_W;
%                 obj.max_wheel_torque_table = min(obj.max_wheel_torque_Nm, obj.max_wheel_power_W ./ max(eps,obj.max_wheel_torque_vspeed_mps ./ vehicle.drive_axle1.tire.radius_m));
% 
%         end
%                
%         function val = get.pedal_map_engine_torque_Nm(obj)
%             
%             if  obj.pedal_map_type == enum_engine_pedal_map_type.lookup_table
%                
%                 val = obj.pedal_map_engine_torque_Nm;
%                 return
%                 
%             end
%             
%             if  isempty( obj.engine_torque_range_speed_radps) || isempty( obj.engine_max_torque_Nm) || isempty( obj.engine_min_torque_Nm)                
%                 error('Misssing engine torque information, specify engine when constructing class')
%             end    
% 
%             % Slightly less than lower torque curve to ensure 
%             pedal_min_torque_Nm = obj.engine_min_torque_Nm*1.01;
%             
%            switch( obj.pedal_map_type)
% 
%                case  enum_engine_pedal_map_type.linear_WOT
%                    pedal_max_torque_Nm = obj.engine_max_torque_Nm;
% 
%                 case enum_engine_pedal_map_type.linear_max_engine_torque
%                     pedal_max_torque_Nm = max(obj.engine_max_torque_Nm) * ones( size(obj.engine_max_torque_Nm));
% 
%                 case enum_engine_pedal_map_type.max_engine_power
%                     max_power_W =  max( obj.engine_max_torque_Nm .* obj.engine_torque_range_speed_radps);
%                     pedal_max_torque_Nm =  max_power_W ./ max(obj.engine_torque_range_speed_radps, obj.engine_idle_speed_radps);
% 
%                 case enum_engine_pedal_map_type.linear_enhanced_WOT
%                     pedal_max_torque_Nm = 1.1 * obj.engine_max_torque_Nm;
% 
%                 case enum_engine_pedal_map_type.linear_enhanced_max_engine_torque
%                     pedal_max_torque_Nm = 1.1* max(obj.engine_max_torque_Nm) * ones( size(obj.engine_max_torque_Nm));
% 
%                 otherwise
%                     error('Unknown pedal map type : %s', obj.pedal_map_type);
%            end
%             
%             val = class_REVS_dynamic_lookup();
%             val.axis_1.signal = 'driver_acl_norm';
%             val.axis_1.breakpoints = [0,1];
%             val.axis_2.signal = 'eng_spd_radps';
%             val.axis_2.breakpoints = obj.engine_torque_range_speed_radps;
%             val.table = [pedal_min_torque_Nm;pedal_max_torque_Nm];
%                
%         end    
%                         
%         end
        
end
    
